Subject: Re: deadlocks on pernet_ops_rwsem

From: Jakub Kicinski <[email-masked]>
Date: Wed, 1 Oct 2025 10:22:23 -0700

On Wed, 1 Oct 2025 18:46:16 +0200 Paolo Abeni wrote:
> Not many here. The above are debug builds, so we should get a lockdep
> splat on deadlock, the logs lack it. I guess the request_module() breaks
> the lockdep checks?

To be clear -- AFAICT lockdep misses this.

The splat is from the "stuck task" checker. 

2 min wait to load a module during test init would definitely be a sign
of something going sideways.. but I think it's worse than that, these
time out completely and we kill the VM. I think the modprobe is truly
stuck here.

In one of the splats lockdep was able to say:

[ 4302.448228][   T44] INFO: task modprobe:31634 <writer> blocked on an rw-semaphore likely owned by task kworker/u16:0:12 <reader>

but most are more useless:

[ 4671.090728][   T44] INFO: task modprobe:2342 is blocked on an rw-semaphore, but the owner is not found.

(?!?)